From cced63c696cbbfb65c316fa417892fc3220eeccd Mon Sep 17 00:00:00 2001
From: David Malcolm <dmalcolm@redhat.com>
Date: Mon, 6 May 2019 12:29:05 -0400
Subject: [PATCH 18/28] FIXME: more work on impl-4

FIXME: make various graph fields const

FIXME: tweaks to comment

FIXME: add base_node/edge/graph idea

FIXME: logging tweaks

FIXME: initial implementation of state purging

FIXME: add path_state::validate

FIXME: add xfails; use warning rather than sorry, for the sake of DejaGnu

FIXME: add per-function stats

FIXME: ensure that we can't have empty ECs

FIXME: fix equiv_class::operator==

FIXME: track the number of pathvars purged

FIXME: purge sm state for unrecognized function calls

NOT_FOR_UPSTREAM-CVE-2005-1689-krb5-recvauth.c

FIXME: fix memory leaks; add timing info

FIXME: rework exploded_graph's hash_map

FIXME: more leak fixes

FIXME: purgable sm state

FIXME: add exploded_graph::dump_stats

FIXME: add #enode:#snode ratio

FIXME: add m_PK_AFTER_SUPERNODE_per_snode

FIXME: add exploded_graph::dump_states_for_supernode

FIXME: add timevars for writing .dot files

FIXME: undo accidental commit to path_state::purge

FIXME: save diagnostics until the end

FIXME: only compute shortest_paths once

FIXME: replace saved_diagnostic::emit with diagnostic_manager::emit_saved_diagnostic

FIXME: move exploded_graph::emit_diagnostic and prune_path to diagnostic_manager

FIXME: more tests

FIXME: deduplication of diagnostics

FIXME: add selftest for auto_delete_vec

FIXME: another test

FIXME: add -fdump-analyzer-supergraph and -fdump-analyzer-exploded-graph

FIXME: WIP on better memory model

FIXME: more on better memory model

FIXME: more on better memory model

FIXME: more work on new data model

FIXME: 2019-05-17 WIP on data model

FIXME: 2019-05-18: WIP on data model

FIXME: add options for each warning

FIXME: rename constraints.h/cc to path-state.h/cc

FIXME: put old constraint impl in a namespace

FIXME: constraint_manager class

FIXME: use constraint_manager class

FIXME: 2019-05-21 work on region model

FIXME: 2019-05-22 work on region model

FIXME: 2019-05-23 work on region model

FIXME: function pointers

FIXME: cleanups

FIXME: 2019-05-24 work on region model

FIXME: further region_model cleanups
---
 gcc/analyzer/Make-lang.in                          |     4 +-
 gcc/analyzer/analyzer-logging.h                    |     8 +
 gcc/analyzer/analyzer-plugin.cc                    |     4 +-
 gcc/analyzer/analyzer.h                            |     4 +-
 gcc/analyzer/constraint-manager.cc                 |  2126 ++++
 gcc/analyzer/constraint-manager.h                  |   243 +
 gcc/analyzer/constraints.cc                        |  1987 ----
 gcc/analyzer/constraints.h                         |   279 -
 gcc/analyzer/digraph.cc                            |     2 +
 gcc/analyzer/digraph.h                             |    73 +
 gcc/analyzer/engine.cc                             |    17 +-
 gcc/analyzer/hardcoded-state-machine-file.cc       |    33 +-
 gcc/analyzer/hardcoded-state-machine-malloc.cc     |   245 +-
 .../hardcoded-state-machine-pattern-test.cc        |    20 +-
 gcc/analyzer/hardcoded-state-machine-sensitive.cc  |    40 +-
 gcc/analyzer/hardcoded-state-machine-taint.cc      |    21 +-
 gcc/analyzer/hardcoded-state-machine.h             |    68 +-
 gcc/analyzer/impl-3.cc                             |    17 +-
 gcc/analyzer/impl-4.cc                             |  2691 ++++-
 gcc/analyzer/path-state.cc                         |  2270 ++++
 gcc/analyzer/path-state.h                          |   315 +
 gcc/analyzer/region-model.cc                       |  3603 +++++++
 gcc/analyzer/region-model.h                        |   820 ++
 gcc/analyzer/supergraph.cc                         |    90 +-
 gcc/analyzer/supergraph.h                          |    53 +-
 gcc/builtins.def                                   |     3 +
 gcc/common.opt                                     |    62 +
 gcc/diagnostic-core.h                              |     7 +-
 gcc/diagnostic.c                                   |     4 +-
 gcc/function-tests.c                               |     4 +-
 gcc/selftest.h                                     |     7 +
 .../malloc-checker/arg_must_not_be_null/input.c    |    30 -
 .../malloc-checker/arg_must_not_be_null/script.py  |    23 -
 .../malloc-checker/arg_must_not_be_null/stderr.txt |     4 -
 .../malloc-checker/arg_must_not_be_null/stdout.txt |     0
 .../checkers/malloc-checker/double_free/input.c    |    29 -
 .../double_free/input.c.cpychecker-log.txt         |     1 -
 .../checkers/malloc-checker/double_free/script.py  |    23 -
 .../checkers/malloc-checker/double_free/stderr.txt |     7 -
 .../checkers/malloc-checker/double_free/stdout.txt |     0
 .../checkers/signal_handler/example/stderr.txt     |     5 -
 .../checkers/signal_handler/example/stdout.txt     |     0
 .../regression/rhs-is-vardecl/stdout.txt           |     0
 .../NOT_FOR_UPSTREAM-CVE-2005-1689-krb5-recvauth.c | 10749 +++++++++++++++++++
 .../NOT_FOR_UPSTREAM-clang-paper-example-1.c       |    12 +
 .../NOT_FOR_UPSTREAM-clang-paper-example-2.c       |    19 +
 .../NOT_FOR_UPSTREAM-clang-paper-example-3.c       |    24 +
 .../NOT_FOR_UPSTREAM-clang-paper-example-4.c       |    31 +
 gcc/testsuite/gcc.dg/analyzer/abort.c              |     2 +
 gcc/testsuite/gcc.dg/analyzer/alloca-leak.c        |     8 +
 gcc/testsuite/gcc.dg/analyzer/attribute-nonnull.c  |    57 +
 gcc/testsuite/gcc.dg/analyzer/conditionals.c       |     2 +
 gcc/testsuite/gcc.dg/analyzer/data-model-1.c       |   790 ++
 gcc/testsuite/gcc.dg/analyzer/equivalence.c        |     2 +
 gcc/testsuite/gcc.dg/analyzer/fibonacci.c          |     5 +-
 gcc/testsuite/gcc.dg/analyzer/fields.c             |    41 +
 gcc/testsuite/gcc.dg/analyzer/function-ptr-2.c     |    28 +
 gcc/testsuite/gcc.dg/analyzer/gzio.c               |     3 +-
 gcc/testsuite/gcc.dg/analyzer/loop.c               |     4 +
 gcc/testsuite/gcc.dg/analyzer/malloc-1.c           |    29 +
 gcc/testsuite/gcc.dg/analyzer/malloc-dedupe-1.c    |    48 +
 gcc/testsuite/gcc.dg/analyzer/malloc-paths-8.c     |     2 +-
 gcc/testsuite/gcc.dg/analyzer/malloc-vs-local.c    |    83 +
 gcc/testsuite/gcc.dg/analyzer/operations.c         |     2 +
 gcc/testsuite/gcc.dg/analyzer/params-2.c           |     2 +
 gcc/testsuite/gcc.dg/analyzer/params.c             |     2 +
 gcc/testsuite/gcc.dg/analyzer/pragma-1.c           |    26 +
 gcc/testsuite/gcc.dg/analyzer/switch.c             |     2 +
 gcc/vec.c                                          |    27 +
 notes.txt                                          |    14 +
 70 files changed, 24272 insertions(+), 2984 deletions(-)
 create mode 100644 gcc/analyzer/constraint-manager.cc
 create mode 100644 gcc/analyzer/constraint-manager.h
 delete mode 100644 gcc/analyzer/constraints.cc
 delete mode 100644 gcc/analyzer/constraints.h
 create mode 100644 gcc/analyzer/path-state.cc
 create mode 100644 gcc/analyzer/path-state.h
 create mode 100644 gcc/analyzer/region-model.cc
 create mode 100644 gcc/analyzer/region-model.h
 delete mode 100644 gcc/testsuite/gcc.dg/TODO-analyzer/checkers/malloc-checker/arg_must_not_be_null/input.c
 delete mode 100644 gcc/testsuite/gcc.dg/TODO-analyzer/checkers/malloc-checker/arg_must_not_be_null/script.py
 delete mode 100644 gcc/testsuite/gcc.dg/TODO-analyzer/checkers/malloc-checker/arg_must_not_be_null/stderr.txt
 delete mode 100644 gcc/testsuite/gcc.dg/TODO-analyzer/checkers/malloc-checker/arg_must_not_be_null/stdout.txt
 delete mode 100644 gcc/testsuite/gcc.dg/TODO-analyzer/checkers/malloc-checker/double_free/input.c
 delete mode 100644 gcc/testsuite/gcc.dg/TODO-analyzer/checkers/malloc-checker/double_free/input.c.cpychecker-log.txt
 delete mode 100644 gcc/testsuite/gcc.dg/TODO-analyzer/checkers/malloc-checker/double_free/script.py
 delete mode 100644 gcc/testsuite/gcc.dg/TODO-analyzer/checkers/malloc-checker/double_free/stderr.txt
 delete mode 100644 gcc/testsuite/gcc.dg/TODO-analyzer/checkers/malloc-checker/double_free/stdout.txt
 delete mode 100644 gcc/testsuite/gcc.dg/TODO-analyzer/checkers/signal_handler/example/stderr.txt
 delete mode 100644 gcc/testsuite/gcc.dg/TODO-analyzer/checkers/signal_handler/example/stdout.txt
 delete mode 100644 gcc/testsuite/gcc.dg/TODO-analyzer/regression/rhs-is-vardecl/stdout.txt
 create mode 100644 gcc/testsuite/gcc.dg/analyzer/NOT_FOR_UPSTREAM-CVE-2005-1689-krb5-recvauth.c
 create mode 100644 gcc/testsuite/gcc.dg/analyzer/NOT_FOR_UPSTREAM-clang-paper-example-1.c
 create mode 100644 gcc/testsuite/gcc.dg/analyzer/NOT_FOR_UPSTREAM-clang-paper-example-2.c
 create mode 100644 gcc/testsuite/gcc.dg/analyzer/NOT_FOR_UPSTREAM-clang-paper-example-3.c
 create mode 100644 gcc/testsuite/gcc.dg/analyzer/NOT_FOR_UPSTREAM-clang-paper-example-4.c
 create mode 100644 gcc/testsuite/gcc.dg/analyzer/alloca-leak.c
 create mode 100644 gcc/testsuite/gcc.dg/analyzer/attribute-nonnull.c
 create mode 100644 gcc/testsuite/gcc.dg/analyzer/data-model-1.c
 create mode 100644 gcc/testsuite/gcc.dg/analyzer/fields.c
 create mode 100644 gcc/testsuite/gcc.dg/analyzer/malloc-dedupe-1.c
 create mode 100644 gcc/testsuite/gcc.dg/analyzer/malloc-vs-local.c
 create mode 100644 gcc/testsuite/gcc.dg/analyzer/pragma-1.c

diff --git a/gcc/analyzer/Make-lang.in b/gcc/analyzer/Make-lang.in
index f742b9d..73cbf4e 100644
--- a/gcc/analyzer/Make-lang.in
+++ b/gcc/analyzer/Make-lang.in
@@ -57,7 +57,7 @@ ANALYZER_PLUGIN_SO_OBJS = \
 	analyzer/analyzer-pass.o \
 	analyzer/analyzer-plugin.o \
 	analyzer/checker-script.o \
-	analyzer/constraints.o \
+	analyzer/constraint-manager.o \
 	analyzer/digraph.o \
 	analyzer/engine.o \
 	analyzer/graphviz.o \
@@ -69,6 +69,8 @@ ANALYZER_PLUGIN_SO_OBJS = \
 	analyzer/hardcoded-state-machine-taint.o \
 	analyzer/impl-3.o \
 	analyzer/impl-4.o \
+	analyzer/path-state.o \
+	analyzer/region-model.o \
 	analyzer/supergraph.o \
 	analyzer/tristate.o \
 
diff --git a/gcc/analyzer/analyzer-logging.h b/gcc/analyzer/analyzer-logging.h
index e09ed8e8..8f950d9 100644
--- a/gcc/analyzer/analyzer-logging.h
+++ b/gcc/analyzer/analyzer-logging.h
@@ -55,6 +55,8 @@ class logger
     ATTRIBUTE_GCC_DIAG(3, 0);
   void exit_scope (const char *scope_name);
 
+  pretty_printer *get_printer () const { return m_pp; }
+
 private:
   int m_refcount;
   FILE *m_f_out;
@@ -160,6 +162,12 @@ class log_user
   void enter_scope (const char *scope_name);
   void exit_scope (const char *scope_name);
 
+  pretty_printer *get_logger_pp () const
+  {
+    gcc_assert (m_logger);
+    return m_logger->get_printer ();
+  }
+
  private:
   logger *m_logger;
 };
diff --git a/gcc/analyzer/analyzer-plugin.cc b/gcc/analyzer/analyzer-plugin.cc
index 17b69bd..781ae8a 100644
--- a/gcc/analyzer/analyzer-plugin.cc
+++ b/gcc/analyzer/analyzer-plugin.cc
@@ -38,9 +38,11 @@ static void
 analyzer_selftests (void */*gcc_data*/, void */*user_data*/)
 {
   analyzer_checker_script_cc_tests ();
-  analyzer_constraints_cc_tests ();
+  analyzer_constraint_manager_cc_tests ();
   analyzer_engine_cc_tests ();
   analyzer_impl_4_cc_tests ();
+  analyzer_path_state_cc_tests ();
+  analyzer_region_model_cc_tests ();
 }
 
 } /* end of namespace selftest.  */
diff --git a/gcc/analyzer/analyzer.h b/gcc/analyzer/analyzer.h
index 32a6ab9..b34ca99 100644
--- a/gcc/analyzer/analyzer.h
+++ b/gcc/analyzer/analyzer.h
@@ -51,9 +51,11 @@ namespace selftest {
 /* Declarations for specific families of tests (by source file), in
    alphabetical order, for the checker plugin.  */
 extern void analyzer_checker_script_cc_tests ();
-extern void analyzer_constraints_cc_tests ();
+extern void analyzer_constraint_manager_cc_tests ();
 extern void analyzer_engine_cc_tests ();
 extern void analyzer_impl_4_cc_tests ();
+extern void analyzer_path_state_cc_tests ();
+extern void analyzer_region_model_cc_tests ();
 
 } /* end of namespace selftest.  */
 
